;;;; memoized-string.scm  -*- Hen -*-
;;;; Kon Lovett, Oct '17
;;;; Kon Lovett, Aug '10

(module memoized-string

;FIXME should export 'global-string', 'string' & 'make-string'
(;export
  global-string
  make-string+
  string+
  ;DEPRECATED
  memorize-string
  make-string*)

(import scheme)

(import chicken)

(import
  (only srfi-1 every)
  (only srfi-69
    make-hash-table
    string-hash
    hash-table-ref/default hash-table-set!)
  (only unicode-utils
    ascii-codepoint?
    *unicode-string
    generic-make-string)
  (only type-checks
    check-natural-fixnum check-char check-string))
(require-library srfi-1 srfi-69 unicode-utils type-checks)

;;

(define *empty-string* "")

;;

(: global-string (string -> string))
(define (global-string str)
  (*make-string+ (check-string 'memorize-string str)) )

;;

(: string+ (#!rest (list-of char) -> string))
(define (string+ . chars)
  (every (cut check-char 'string+ <>) chars)
  (*make-string+ (*unicode-string chars)) )

;; Memeoized `make-string'

;len - length of string in chars
(: make-string+ (number #!optional char -> string))
(define (make-string+ len #!optional (fill #\space))
  (*make-string+
    (check-natural-fixnum 'make-string+ len)
    (check-char 'make-string+ fill)) )

;;

(define *make-string+
  (let ((+global-strings+ (make-hash-table equal?)))
    ;
    (define (addTop len ch dat)
      (let ((key `(,len . ,ch)))
        (or
          (hash-table-ref/default +global-strings+ key #f)
          (let ((dat (force dat)))
            (hash-table-set! +global-strings+ key dat)
            dat ) ) ) )
    ;
    (define (addStr len ch str)
      (let (
        (strtbl (addTop len ch (delay (make-hash-table string=? string-hash))) )
        (str (force str) ) )
        ;
        (or
          (hash-table-ref/default strtbl str #f)
          (begin
            (hash-table-set! strtbl str str)
            str ) ) ) )
    ;
    (case-lambda
      ((str)
        (let* (
          (len (string-length str) )
          (ch (and (not (fx= 0 len)) (string-ref str 0)) ) )
          ;
          (*make-string+ len ch str) ) )
      ((len ch)
        (*make-string+ len ch (delay (generic-make-string len ch))) )
      ((len ch str)
        (if (fx= 0 len)
          *empty-string*
          (addStr len ch str) ) ) ) ) )

;DEPRECATED
(define memorize-string global-string)
(define make-string* make-string+)

) ;module memoized-string
